##### Imports #####

import os
from re import S
import math
import streamlit as st
import matplotlib as plt
import pandas as pd
import textwrap
import statsmodels.formula.api as smf
import statsmodels.tsa.api as smt
import statsmodels.api as sm
import scipy.stats as scs
import numba
import numpy as np
import seaborn as sns

import matplotlib.cm as cm
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import colors
import matplotlib.pyplot as plt
import altair as alt

##### Plotly ######
import plotly.express as px
import plotly.graph_objects as go
import plotly.figure_factory as ff
import plotly.graph_objects as go
import chart_studio
from plotly import tools
from plotly.subplots import make_subplots

import time #from datetime import datetime
import datetime


from scipy.fftpack import rfft
from scipy.stats import boxcox
from sklearn.cluster import AgglomerativeClustering, KMeans
from sklearn.metrics import davies_bouldin_score
from sklearn_extra.cluster import KMedoids
from sklearn.metrics import calinski_harabasz_score
from scipy.cluster.hierarchy import single, complete, average, ward, dendrogram, linkage
from sklearn.metrics.cluster import contingency_matrix
from sklearn.manifold import TSNE
from sklearn.preprocessing import MinMaxScaler
from sklearn.cluster import KMeans
from sklearn.impute import SimpleImputer

from datetime import timedelta #from datetime import datetime


# Algorithms
from tslearn.barycenters import dtw_barycenter_averaging
from tslearn.clustering import TimeSeriesKMeans
from sktime.distances import dtw_distance
from dtaidistance import clustering, dtw
#from fcmeans import FCM


# IMplementation for pyclustering kmeans
from pyclustering.cluster.kmeans import kmeans
from pyclustering.cluster.center_initializer import random_center_initializer
from pyclustering.cluster.encoder import type_encoding
from pyclustering.cluster.encoder import cluster_encoder
from pyclustering.utils.metric import distance_metric
from pyclustering.cluster.center_initializer import kmeans_plusplus_initializer
from pyclustering.cluster.fcm import fcm
from sklearn.metrics import pairwise_distances
from validclust import cop, dunn


# Preprocessing
from sklearn.preprocessing import MinMaxScaler
from sklearn.metrics.cluster import contingency_matrix
from tslearn.clustering import TimeSeriesKMeans
from tslearn.preprocessing import TimeSeriesScalerMeanVariance
from netdata_pandas.data import get_data, get_chart_list
from am4894plots.plots import plot_lines, plot_lines_grid
from matplotlib.patches import Ellipse
from sklearn import preprocessing

#from sklearn.cluster import KMeans
from sklearn.metrics import silhouette_score, silhouette_samples
from yellowbrick.cluster import SilhouetteVisualizer, KElbowVisualizer
from sklearn.model_selection import train_test_split



####### DEF for null values #####

def null_values(df):
    null_test = (df.isnull().sum(axis=0) / len(df)).sort_values(ascending=False).index
    null_data_test = pd.concat([
        df.isnull().sum(axis=0),
        (df.isnull().sum(axis=0) / len(df)).sort_values(ascending=False),
        df.loc[:, df.columns.isin(list(null_test))].dtypes], axis=1)
    null_data_test = null_data_test.rename(columns={0: '# null',
                                                    1: '% null',
                                                    2: 'type'}).sort_values(ascending=False, by='% null')
    null_data_test = null_data_test[null_data_test["# null"] != 0]

    return null_data_test



def type(df):
    return pd.DataFrame(df.dtypes, columns=['Type'])

def preprocessing_meanvar(df):
    X = TimeSeriesScalerMeanVariance().fit_transform(X)
    df = pd.DataFrame(X.reshape(df.shape), columns=df.columns, index=df.index)
    return df


def purity_score(y_true, y_pred):
    # compute contingency matrix (also called confusion matrix)
    confusion_matrix = contingency_matrix(y_true, y_pred)
    # return purity
    return np.sum(np.amax(confusion_matrix, axis=0)) / np.sum(confusion_matrix)


## 1. Exploratory Data Analysis
def exploratory_data_analysis(data):
    """
    Perform exploratory data analysis on a dataset with 15-minute time intervals.

    Args:
        data (pd.DataFrame): Input dataset with a datetime column named 'Time'.

    Returns:
        pd.DataFrame: Processed DataFrame with additional features.
    """
    # Ensure 'Time' column is in datetime format
    data['Time'] = pd.to_datetime(data['Time'])

    # Set 'Time' column as the index
    data.set_index('Time', inplace=True)

    # Extract temporal features
    data['Hour'] = data.index.hour
    data['Minute'] = data.index.minute
    data['Day'] = data.index.day
    data['Weekday'] = data.index.weekday  # 0=Monday, 6=Sunday
    data['Month'] = data.index.month
    data['DayOfYear'] = data.index.dayofyear

    # Check for missing values and impute with column mean
    imputer = SimpleImputer(strategy="mean")
    data.iloc[:, :] = imputer.fit_transform(data)

    # Display summary statistics
    print(data.describe())

    return data

## preprocess for clustering
## Preprocess for clustering
def preprocess_for_clustering(data):
    """
    Preprocess the data for clustering by aggregating it to a daily level.

    Args:
        data (pd.DataFrame): Input DataFrame containing the time-series data.

    Returns:
        pd.DataFrame: Preprocessed DataFrame aggregated at the daily level, ready for clustering.
    """
    # Load the dataset into a DataFrame
    df = pd.DataFrame(data)

    # Ensure the 'Time' column is in datetime format
    df['Time'] = pd.to_datetime(df['Time'])

    # Check for missing values and impute numerical columns with column mean
    numerical_columns = df.select_dtypes(include=np.number).columns
    imputer = SimpleImputer(strategy="mean")
    df[numerical_columns] = imputer.fit_transform(df[numerical_columns])

    # Extract the date component (day-level aggregation)
    df['Date'] = df['Time'].dt.date

    # Aggregate data by day
    daily_aggregates = df.groupby('Date').agg({
        'ess active power': ['mean', 'sum', 'max', 'min'],
        'grid active power': ['mean', 'sum', 'max', 'min'],
        'Consumption active power': ['mean', 'sum', 'max', 'min'],
        'Production active power': ['mean', 'sum', 'max', 'min']
    })

    # Flatten the multi-level column index
    daily_aggregates.columns = ['_'.join(col).strip() for col in daily_aggregates.columns]

    # Reset index to make 'Date' a column
    daily_aggregates.reset_index(inplace=True)

    return daily_aggregates





import seaborn as sns

import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.dates as mdates

import pandas as pd
import matplotlib.pyplot as plt
import matplotlib.dates as mdates

def process_daily_mean_power(df):

    # Convert the 'Time' column to datetime
    df['Time'] = pd.to_datetime(df['Time'])

    # Set the 'Time' column as the index
    df.set_index('Time', inplace=True)

    # Resample the data to get the mean daily value
    daily_mean = df.resample('D').mean()

    # Reset the index to make 'Time' a column again
    daily_mean = daily_mean.reset_index()

    # Rename 'Time' to 'Date'
    #daily_mean.rename(columns={'Time': 'Date'}, inplace=True)

    # Drop rows with NaN values
    daily_mean.dropna(inplace=True)

    

    return daily_mean


def plot_daily_mean_power(daily_mean):
    """
    Plots the daily mean power values.

    Parameters:
    daily_mean (pandas.DataFrame): DataFrame containing daily mean values.
    """
    plt.figure(figsize=(10, 6))
    for column in ['ess active power', 'grid active power', 'Consumption active power', 'Production active power']:
        plt.plot(daily_mean['Time'], daily_mean[column], label=column)

    plt.xlabel('Date')
    plt.ylabel('Mean Daily Value')
    plt.title('Mean Daily Power Values')
    plt.legend()
    plt.grid(True)

    # Format x-axis to display dates
    ax = plt.gca()
    ax.xaxis.set_major_formatter(mdates.DateFormatter('%Y-%m-%d'))
    ax.xaxis.set_major_locator(mdates.DayLocator())

    plt.xticks(rotation=45)
    plt.tight_layout()
    plt.show()


# Placeholder SBD distance function
def sbd_distance(x, y):
    # Replace this with the actual SBD implementation if available
    return np.linalg.norm(x - y)

import numpy as np
from sklearn.metrics import silhouette_score, davies_bouldin_score, calinski_harabasz_score
from tslearn.clustering import KShape, TimeSeriesKMeans
from tslearn.metrics import dtw
from sklearn.cluster import AgglomerativeClustering
from aeon.distances import sbd_distance, sbd_pairwise_distance


# Compute additional indices (Dunn, COP, Score Function)
def compute_custom_indices(data, labels):
    """
    Compute Dunn Index, COP Index, and Score Function for clustering validation.

    Args:
        data (np.ndarray): Feature data used for clustering.
        labels (np.ndarray): Cluster labels.

    Returns:
        tuple: (Dunn Index, COP Index, Score Function)
    """
    # Unique clusters
    unique_labels = np.unique(labels)
    clusters = [data[labels == k] for k in unique_labels]

    # Pairwise distances
    def pairwise_distances(cluster):
        n = cluster.shape[0]
        return np.linalg.norm(cluster[:, None, :] - cluster[None, :, :], axis=-1).flatten()

    # Dunn Index
    inter_cluster_distances = []
    intra_cluster_distances = []

    for i, cluster_i in enumerate(clusters):
        # Intra-cluster distance
        if len(cluster_i) > 1:
            intra_cluster_distances.append(pairwise_distances(cluster_i).max())
        else:
            intra_cluster_distances.append(0)

        # Inter-cluster distances
        for j, cluster_j in enumerate(clusters):
            if i != j:
                dist = np.linalg.norm(
                    cluster_i[:, None, :] - cluster_j[None, :, :], axis=-1
                ).min()
                inter_cluster_distances.append(dist)

    dunn_index = min(inter_cluster_distances) / max(intra_cluster_distances)

    # COP Index
    inter_dists = []
    intra_dists = []

    for cluster in clusters:
        if len(cluster) > 1:
            intra_dists.append(pairwise_distances(cluster).mean())
        else:
            intra_dists.append(0)

    for i, cluster_i in enumerate(clusters):
        for j, cluster_j in enumerate(clusters):
            if i != j:
                inter_dists.append(
                    np.linalg.norm(
                        cluster_i[:, None, :] - cluster_j[None, :, :], axis=-1
                    ).mean()
                )

    cop_index = sum(intra_dists) / sum(inter_dists)

    # Score Function (SF) Index
    score_function = (len(unique_labels) / len(data)) * (np.mean(intra_cluster_distances) / np.mean(inter_cluster_distances))

    return dunn_index, cop_index, score_function


def evaluate_clustering(labels, data, output_file="clustering_cvi.csv"):
    """
    Evaluate clustering performance with various validity indices and save them to a CSV file.

    Args:
        labels (np.ndarray): Cluster labels.
        data (np.ndarray): Data used for clustering.
        output_file (str): Path to save the CSV file with cluster validity indices.

    Returns:
        dict: Dictionary of validity indices.
    """
    # Standard indices
    sil = silhouette_score(data, labels, metric="euclidean")
    db = davies_bouldin_score(data, labels)
    ch = calinski_harabasz_score(data, labels)
    
    # Custom indices
    dunn, cop, sf = compute_custom_indices(data, labels)
    
    # Store indices in a dictionary
    cvi_results = {
        "Silhouette Score": sil,
        "Davies-Bouldin Score": db,
        "Calinski-Harabasz Score": ch,
        "Dunn Index": dunn,
        "COP Index": cop,
        "Score Function": sf,
    }

    # Save results to a CSV file
    pd.DataFrame([cvi_results]).to_csv(output_file, index=False)
    print(f"Cluster validity indices saved to {output_file}")

    return cvi_results


# Clustering function
def cluster_daily_aggregates(data, clustering_method="K-shape", distance_metric="Euclidean", n_clusters=3):
    """
    Cluster daily aggregates using various methods and evaluate clustering performance.

    Args:
        data (pd.DataFrame): Preprocessed daily aggregate DataFrame.
        clustering_method (str): The clustering method to use.
        distance_metric (str): The distance metric to use.
        n_clusters (int): The number of clusters.

    Returns:
        dict: Dictionary with clustering labels, method details, and evaluation metrics.
    """
    # Prepare data for clustering (drop the date column)
    features = data.drop(columns=["Time"]).values

    # Normalize features for clustering
    features = (features - np.mean(features, axis=1, keepdims=True)) / np.std(features, axis=1, keepdims=True)

    # Initialize model based on method and distance
    if clustering_method == "PAM":
        if distance_metric not in ["Euclidean", "DTW"]:
            raise ValueError("PAM supports only Euclidean and DTW.")
        model = KMedoids(n_clusters=n_clusters, metric=distance_metric.lower())
    elif clustering_method == "K-shape":
        #if distance_metric != "SBD":
        #    raise ValueError("K-shape requires SBD as the distance metric.")
        model = KShape(n_clusters=n_clusters)
    elif clustering_method == "DBA":
        if distance_metric != "DTW":
            raise ValueError("DBA requires DTW as the distance metric.")
        model = TimeSeriesKMeans(n_clusters=n_clusters, metric="dtw", method="dba")
    elif clustering_method in ["Single", "Average", "Complete", "Ward", "Centroid", "Median"]:
        linkage = clustering_method.lower()
        affinity = distance_metric.lower()
        if affinity not in ["euclidean", "dtw", "sbd"]:
            raise ValueError("Hierarchical supports only Euclidean, DTW, and SBD.")
        model = AgglomerativeClustering(n_clusters=n_clusters, linkage=linkage, affinity="precomputed")
        # Compute pairwise distance matrix
        distance_func = {"euclidean": np.linalg.norm, "dtw": dtw, "sbd": sbd_pairwise_distance}[affinity]
        distance_matrix = np.array([[distance_func(x, y) for y in features] for x in features])
        labels = model.fit_predict(distance_matrix)
    else:
        raise ValueError(f"Invalid clustering method: {clustering_method}")

    # Fit the model and get labels
    if clustering_method not in ["Single", "Average", "Complete", "Ward", "Centroid", "Median"]:
        labels = model.fit_predict(features)

    # Evaluate clustering with indices
    indices = evaluate_clustering(labels, features)

    return {
        "labels": labels,
        **indices,
        "method": clustering_method,
        "metric": distance_metric,
    }


import matplotlib.pyplot as plt
import seaborn as sns

def visualize_clusters(daily_aggregates, labels):
    """
    Visualize clustering results on the daily aggregates for all features.

    Args:
        daily_aggregates (pd.DataFrame): Preprocessed daily aggregates data.
        labels (array-like): Cluster labels for each day.
    """
    # Add cluster labels to the daily aggregates DataFrame
    daily_aggregates['Cluster'] = labels

    # Features to visualize
    features_to_plot = [
        'ess active power',
        'grid active power',
        'Consumption active power',
        'Production active power'
    ]

    plt.figure(figsize=(16, 8))

    for idx, feature in enumerate(features_to_plot, 1):
        plt.subplot(2, 2, idx)
        sns.scatterplot(
            x=daily_aggregates['Time'],
            y=daily_aggregates[feature],
            hue=daily_aggregates['Cluster'],
            palette="viridis",
            s=100,
            edgecolor="k",
        )
        plt.title(f'Cluster Visualization for {feature}', fontsize=14)
        plt.xlabel('Date', fontsize=12)
        plt.ylabel(feature, fontsize=12)
        plt.xticks(rotation=45)
        plt.grid(True, linestyle="--", alpha=0.7)

    plt.tight_layout()
    plt.show()

import matplotlib.pyplot as plt
import seaborn as sns
import pandas as pd

def visualize_clusters_over_time(daily_aggregates, labels):
    """
    Visualize clustering results over time for each feature.

    Args:
        daily_aggregates (pd.DataFrame): Preprocessed daily aggregates data.
        labels (array-like): Cluster labels for each day.
    """
    # Add cluster labels to the daily aggregates DataFrame
    daily_aggregates['Cluster'] = labels

    # Features to visualize
    features_to_plot = [
        'ess active power',
        'grid active power',
        'Consumption active power',
        'Production active power'
    ]

    plt.figure(figsize=(16, 12))

    for idx, feature in enumerate(features_to_plot, 1):
        plt.subplot(2, 2, idx)
        for cluster in sorted(daily_aggregates['Cluster'].unique()):
            cluster_data = daily_aggregates[daily_aggregates['Cluster'] == cluster]
            plt.plot(cluster_data['Time'], cluster_data[feature], label=f'Cluster {cluster}', linewidth=2)
        
        plt.title(f'Cluster Visualization for {feature}', fontsize=14)
        plt.xlabel('Date', fontsize=12)
        plt.ylabel(feature, fontsize=12)
        plt.xticks(rotation=45)
        plt.grid(True, linestyle="--", alpha=0.7)
        plt.legend()

    plt.tight_layout()
    plt.show()

import matplotlib.pyplot as plt
import seaborn as sns
import pandas as pd
from sklearn.preprocessing import MinMaxScaler


# Visualize clustering results using a heatmap
import matplotlib.pyplot as plt
import seaborn as sns
import pandas as pd
import numpy as np
from matplotlib.colors import ListedColormap


# Visualize clustering results using a heatmap
def visualize_clusters_heatmap(daily_aggregates, labels):
    """
    Visualize clustering results using a heatmap with months on the x-axis, days on the y-axis, and distinct colors for each cluster.

    Args:
        daily_aggregates (pd.DataFrame): Preprocessed daily aggregates data.
        labels (array-like): Cluster labels for each day.
    """
    # Increment cluster labels by 1 to start from 1 instead of 0
    labels = labels + 1

    # Add cluster labels to the daily aggregates DataFrame
    daily_aggregates['Cluster'] = labels

    # Extract month and day from the 'Time' column
    daily_aggregates['Month'] = daily_aggregates['Time'].dt.strftime('%b')  # Abbreviated month name (e.g., Jan, Feb)
    daily_aggregates['Day'] = daily_aggregates['Time'].dt.day  # Day of the month (1 to 31)

    # Pivot the data for heatmap: Months on x-axis, Days on y-axis, and Clusters as values
    heatmap_data = daily_aggregates.pivot_table(index='Day', columns='Month', values='Cluster', aggfunc='first')

    # Ensure all days (1 to 31) are included in the heatmap and in ascending order
    heatmap_data = heatmap_data.reindex(index=range(1, 32), columns=pd.date_range(start='2023-01-01', periods=12, freq='M').strftime('%b'))

    # Create a categorical color palette for clusters
    unique_clusters = np.unique(labels)
    cluster_palette = sns.color_palette("husl", n_colors=len(unique_clusters))  # Use a distinct color for each cluster
    cluster_cmap = ListedColormap(cluster_palette)

    # Plot the heatmap
    plt.figure(figsize=(12, 8))
    sns.heatmap(
        heatmap_data,
        cmap=cluster_cmap,
        annot=False,
        linewidths=0.5,
        cbar_kws={'ticks': unique_clusters, 'label': 'Cluster'}
    )

    plt.title('Cluster Distribution by Month and Day', fontsize=16)
    plt.xlabel('Month', fontsize=14)
    plt.ylabel('Day of Month', fontsize=14)
    plt.xticks(rotation=45)
    plt.yticks(rotation=0)

    plt.tight_layout()
    plt.show()


# Visualize clustering results by hour of the day
def visualize_clusters_by_hour(daily_aggregates, labels):
    """
    Visualize clustering results by hour of the day with normalized data.

    Args:
        daily_aggregates (pd.DataFrame): Preprocessed daily aggregates data.
        labels (array-like): Cluster labels for each day.
    """
    # Add cluster labels to the daily aggregates DataFrame
    daily_aggregates['Cluster'] = labels

    # Extract the hour from the 'Time' column
    daily_aggregates['Hour'] = daily_aggregates['Time'].dt.hour

    # Features to visualize
    features_to_plot = [
        'ess active power',
        'grid active power',
        'Consumption active power',
        'Production active power'
    ]

    # Normalize the features
    scaler = MinMaxScaler()
    daily_aggregates[features_to_plot] = scaler.fit_transform(daily_aggregates[features_to_plot])

    plt.figure(figsize=(16, 12))

    for idx, feature in enumerate(features_to_plot, 1):
        plt.subplot(2, 2, idx)
        sns.boxplot(
            x='Hour',
            y=feature,
            hue='Cluster',
            data=daily_aggregates,
            palette="viridis"
        )
        plt.title(f'Cluster Visualization for {feature} by Hour', fontsize=14)
        plt.xlabel('Hour of the Day', fontsize=12)
        plt.ylabel(feature, fontsize=12)
        plt.grid(True, linestyle="--", alpha=0.7)
        plt.legend(title='Cluster')

        # Set x-axis ticks to include all 24 hours
        plt.xticks(ticks=range(0, 24), labels=[f"{i}:00" for i in range(24)], rotation=45)

    plt.tight_layout()
    plt.show()



# Visualize features using heatmaps
def visualize_features_heatmap(daily_aggregates):
    """
    Visualize features using heatmaps with months on the x-axis, days on the y-axis (ascending from bottom to top),
    and actual feature values as colors.

    Args:
        daily_aggregates (pd.DataFrame): Preprocessed daily aggregates data.
    """
    # Extract month and day from the 'Time' column
    daily_aggregates['Month'] = daily_aggregates['Time'].dt.strftime('%b')  # Abbreviated month name (e.g., Jan, Feb)
    daily_aggregates['Day'] = daily_aggregates['Time'].dt.day  # Day of the month (1 to 31)

    # Features to visualize
    features_to_plot = [
        'ess active power',
        'grid active power',
        'Consumption active power',
        'Production active power'
    ]

    # Initialize MinMaxScaler for normalization
    scaler = MinMaxScaler()

    # Plot heatmaps for each feature
    plt.figure(figsize=(18, 12))
    for idx, feature in enumerate(features_to_plot, 1):
        plt.subplot(2, 2, idx)
        
        # Pivot the data for heatmap: Months on x-axis, Days on y-axis, and Feature values as colors
        heatmap_data = daily_aggregates.pivot_table(index='Day', columns='Month', values=feature, aggfunc='mean')
        
        # Ensure all days (1 to 31) are included in the heatmap and in ascending order
        heatmap_data = heatmap_data.reindex(index=range(1, 32), columns=pd.date_range(start='2023-01-01', periods=12, freq='M').strftime('%b'))
        
        # Normalize the feature values using MinMaxScaler
        heatmap_data_normalized = pd.DataFrame(scaler.fit_transform(heatmap_data), columns=heatmap_data.columns, index=heatmap_data.index)
        
        # Plot the heatmap
        sns.heatmap(
            heatmap_data_normalized,
            cmap="viridis",  # Use a gradient colormap for feature values
            annot=False,  # No annotations
            linewidths=0.5,
            cbar_kws={'label': f'Normalized {feature}'}
        )
        
        plt.title(f'{feature} by Month and Day', fontsize=14)
        plt.xlabel('Month', fontsize=12)
        plt.ylabel('Day of Month', fontsize=12)
        plt.xticks(rotation=45)
        plt.yticks(rotation=0)

        # Reverse the y-axis to show days in ascending order from bottom to top
        plt.gca().invert_yaxis()

    plt.tight_layout()
    plt.show()



# Example Usage
if __name__ == "__main__":
    # Step 1: Load the dataset
    data = pd.read_csv("/home/jvaldes/Desktop/krishna-thesis/thesiscodeimplementation/data/EFH (1).csv")  # Replace with your dataset file

    # Process the data to get daily mean values
    daily_mean_df = process_daily_mean_power(data)

    # Cluster the data
    results = cluster_daily_aggregates(
        data=daily_mean_df,
        clustering_method="PAM",  # Choose K-shape
        distance_metric="Euclidean",  # Use "dtw" as the metric string
        n_clusters=5
    )

    # Visualize the clusters
    visualize_clusters(daily_mean_df, results['labels'])

    # Visualize the clusters over time
    visualize_clusters_heatmap(daily_mean_df, results['labels'])

    # Visualize the clusters by hour of the day
    visualize_clusters_by_hour(daily_mean_df, results['labels'])

    # Visualize the features using heatmaps
    visualize_features_heatmap(daily_mean_df)



