##### Imports #####

import os
from re import S
import math
import streamlit as st
import matplotlib as plt
import pandas as pd
import textwrap
import statsmodels.formula.api as smf
import statsmodels.tsa.api as smt
import statsmodels.api as sm
import scipy.stats as scs
import numba
import numpy as np
import seaborn as sns

import matplotlib.cm as cm
from mpl_toolkits.mplot3d import Axes3D
from matplotlib import colors
import matplotlib.pyplot as plt
import altair as alt

##### Plotly ######
import plotly.express as px
import plotly.graph_objects as go
import plotly.figure_factory as ff
import plotly.graph_objects as go
import chart_studio
from plotly import tools
from plotly.subplots import make_subplots

import time #from datetime import datetime
import datetime


from scipy.fftpack import rfft
from scipy.stats import boxcox
from sklearn.cluster import AgglomerativeClustering, KMeans
from sklearn.metrics import davies_bouldin_score
from sklearn_extra.cluster import KMedoids
from sklearn.metrics import calinski_harabasz_score
from scipy.cluster.hierarchy import single, complete, average, ward, dendrogram, linkage
from sklearn.metrics.cluster import contingency_matrix
from sklearn.manifold import TSNE
from sklearn.preprocessing import MinMaxScaler
from sklearn.cluster import KMeans
from sklearn.impute import SimpleImputer

from datetime import timedelta #from datetime import datetime


# Algorithms
from tslearn.barycenters import dtw_barycenter_averaging
from tslearn.clustering import TimeSeriesKMeans
from sktime.distances import dtw_distance
from dtaidistance import clustering, dtw
#from fcmeans import FCM


# IMplementation for pyclustering kmeans
from pyclustering.cluster.kmeans import kmeans
from pyclustering.cluster.center_initializer import random_center_initializer
from pyclustering.cluster.encoder import type_encoding
from pyclustering.cluster.encoder import cluster_encoder
from pyclustering.utils.metric import distance_metric
from pyclustering.cluster.center_initializer import kmeans_plusplus_initializer
from pyclustering.cluster.fcm import fcm
from sklearn.metrics import pairwise_distances
from validclust import cop, dunn


# Preprocessing
from sklearn.preprocessing import MinMaxScaler
from sklearn.metrics.cluster import contingency_matrix
from tslearn.clustering import TimeSeriesKMeans
from tslearn.preprocessing import TimeSeriesScalerMeanVariance
from netdata_pandas.data import get_data, get_chart_list
from am4894plots.plots import plot_lines, plot_lines_grid
from matplotlib.patches import Ellipse
from sklearn import preprocessing

#from sklearn.cluster import KMeans
from sklearn.metrics import silhouette_score, silhouette_samples
from yellowbrick.cluster import SilhouetteVisualizer, KElbowVisualizer
from sklearn.model_selection import train_test_split


import matplotlib.pyplot as plt
import seaborn as sns
import pandas as pd
from sklearn.metrics import silhouette_score, davies_bouldin_score, calinski_harabasz_score
from tslearn.clustering import KShape, TimeSeriesKMeans
from tslearn.metrics import dtw
from sklearn.cluster import AgglomerativeClustering
from aeon.distances import sbd_distance, sbd_pairwise_distance
import itertools
import numpy as np
from sklearn.metrics import silhouette_score, davies_bouldin_score, calinski_harabasz_score
#from tslearn.clustering import KMedoids, KShape, TimeSeriesKMeans



####### DEF for null values #####

def null_values(df):
    null_test = (df.isnull().sum(axis=0) / len(df)).sort_values(ascending=False).index
    null_data_test = pd.concat([
        df.isnull().sum(axis=0),
        (df.isnull().sum(axis=0) / len(df)).sort_values(ascending=False),
        df.loc[:, df.columns.isin(list(null_test))].dtypes], axis=1)
    null_data_test = null_data_test.rename(columns={0: '# null',
                                                    1: '% null',
                                                    2: 'type'}).sort_values(ascending=False, by='% null')
    null_data_test = null_data_test[null_data_test["# null"] != 0]

    return null_data_test


def type(df):
    return pd.DataFrame(df.dtypes, columns=['Type'])


def preprocessing_meanvar(df):
    X = TimeSeriesScalerMeanVariance().fit_transform(X)
    df = pd.DataFrame(X.reshape(df.shape), columns=df.columns, index=df.index)
    return df


def purity_score(y_true, y_pred):
    # compute contingency matrix (also called confusion matrix)
    confusion_matrix = contingency_matrix(y_true, y_pred)
    # return purity
    return np.sum(np.amax(confusion_matrix, axis=0)) / np.sum(confusion_matrix)


## 1. Exploratory Data Analysis
def exploratory_data_analysis(data):
    """
    Perform exploratory data analysis on a dataset with 15-minute time intervals.

    Args:
        data (pd.DataFrame): Input dataset with a datetime column named 'Time'.

    Returns:
        pd.DataFrame: Processed DataFrame with additional features.
    """
    # Ensure 'Time' column is in datetime format
    data['Time'] = pd.to_datetime(data['Time'])

    # Set 'Time' column as the index
    data.set_index('Time', inplace=True)

    # Extract temporal features
    data['Hour'] = data.index.hour
    data['Minute'] = data.index.minute
    data['Day'] = data.index.day
    data['Weekday'] = data.index.weekday  # 0=Monday, 6=Sunday
    data['Month'] = data.index.month
    data['DayOfYear'] = data.index.dayofyear

    # Check for missing values and impute with column mean
    imputer = SimpleImputer(strategy="mean")
    data.iloc[:, :] = imputer.fit_transform(data)

    # Display summary statistics
    print(data.describe())

    return data


## Preprocess for clustering
def preprocess_for_clustering(data):
    """
    Preprocess the data for clustering by aggregating it to a daily level.

    Args:
        data (pd.DataFrame): Input DataFrame containing the time-series data.

    Returns:
        pd.DataFrame: Preprocessed DataFrame aggregated at the daily level, ready for clustering.
    """
    # Load the dataset into a DataFrame
    df = pd.DataFrame(data)

    # Ensure the 'Time' column is in datetime format
    df['Time'] = pd.to_datetime(df['Time'])

    # Check for missing values and impute numerical columns with column mean
    numerical_columns = df.select_dtypes(include=np.number).columns
    imputer = SimpleImputer(strategy="mean")
    df[numerical_columns] = imputer.fit_transform(df[numerical_columns])

    # Extract the date component (day-level aggregation)
    df['Date'] = df['Time'].dt.date

    # Aggregate data by day
    daily_aggregates = df.groupby('Date').agg({
        'ess active power': ['mean', 'sum', 'max', 'min'],
        'grid active power': ['mean', 'sum', 'max', 'min'],
        'Consumption active power': ['mean', 'sum', 'max', 'min'],
        'Production active power': ['mean', 'sum', 'max', 'min']
    })

    # Flatten the multi-level column index
    daily_aggregates.columns = ['_'.join(col).strip() for col in daily_aggregates.columns]

    # Reset index to make 'Date' a column
    daily_aggregates.reset_index(inplace=True)

    return daily_aggregates


def plot_daily_mean_power(data):
    # Load the dataset into a DataFrame
    df = pd.DataFrame(data)
    
    # Ensure the 'Time' column is in datetime format
    df['Time'] = pd.to_datetime(df['Time'])
    
    # Set 'Time' as the index
    df.set_index('Time', inplace=True)
    
    # Check for missing values and impute numerical columns with column mean
    numerical_columns = df.select_dtypes(include=np.number).columns
    imputer = SimpleImputer(strategy="mean")
    df[numerical_columns] = imputer.fit_transform(df[numerical_columns])
    
    # Resample the data to get the mean daily value
    daily_mean = df.resample('D').mean()
    
    # Reset the index to make 'Time' a column again
    daily_mean = daily_mean.reset_index()
    
    # Reshape the data to long format
    daily_mean_long = daily_mean.melt(id_vars='Time', var_name='Power_Type', value_name='Mean_Value')
    
    # Set seaborn style
    sns.set(style="ticks")
    
    # Plot the data
    plt.figure(figsize=(14, 7))
    sns.lineplot(data=daily_mean_long, x='Time', y='Mean_Value', hue='Power_Type', linewidth=2.5)
    
    plt.xlabel('Date', fontsize=14)
    plt.ylabel('Mean Daily Value', fontsize=14)
    plt.title('Mean Daily Power Values', fontsize=16)
    plt.legend(title='Power Type', fontsize=12, title_fontsize=12)
    plt.grid(True, which='both', linestyle='--', linewidth=0.5)
    
    # Rotate x-axis labels for better readability
    plt.xticks(rotation=45, fontsize=12)
    plt.yticks(fontsize=12)
    
    # Improve date formatting on x-axis
    plt.gca().xaxis.set_major_locator(plt.MaxNLocator(10))
    plt.gcf().autofmt_xdate()
    
    plt.tight_layout()  # Adjust layout to prevent label overlap
    plt.show()


# Compute additional indices (Dunn, COP, Score Function)
def compute_custom_indices(data, labels):
    """
    Compute Dunn Index, COP Index, and Score Function for clustering validation.

    Args:
        data (np.ndarray): Feature data used for clustering.
        labels (np.ndarray): Cluster labels.

    Returns:
        tuple: (Dunn Index, COP Index, Score Function)
    """
    # Unique clusters
    unique_labels = np.unique(labels)
    clusters = [data[labels == k] for k in unique_labels]

    # Pairwise distances
    def pairwise_distances(cluster):
        n = cluster.shape[0]
        return np.linalg.norm(cluster[:, None, :] - cluster[None, :, :], axis=-1).flatten()

    # Dunn Index
    inter_cluster_distances = []
    intra_cluster_distances = []

    for i, cluster_i in enumerate(clusters):
        # Intra-cluster distance
        if len(cluster_i) > 1:
            intra_cluster_distances.append(pairwise_distances(cluster_i).max())
        else:
            intra_cluster_distances.append(0)

        # Inter-cluster distances
        for j, cluster_j in enumerate(clusters):
            if i != j:
                dist = np.linalg.norm(
                    cluster_i[:, None, :] - cluster_j[None, :, :], axis=-1
                ).min()
                inter_cluster_distances.append(dist)

    dunn_index = min(inter_cluster_distances) / max(intra_cluster_distances)

    # COP Index
    inter_dists = []
    intra_dists = []

    for cluster in clusters:
        if len(cluster) > 1:
            intra_dists.append(pairwise_distances(cluster).mean())
        else:
            intra_dists.append(0)

    for i, cluster_i in enumerate(clusters):
        for j, cluster_j in enumerate(clusters):
            if i != j:
                inter_dists.append(
                    np.linalg.norm(
                        cluster_i[:, None, :] - cluster_j[None, :, :], axis=-1
                    ).mean()
                )

    cop_index = sum(intra_dists) / sum(inter_dists)

    # Score Function (SF) Index
    score_function = (len(unique_labels) / len(data)) * (np.mean(intra_cluster_distances) / np.mean(inter_cluster_distances))

    return dunn_index, cop_index, score_function


# Evaluate clustering performance
def evaluate_clustering(labels, data):
    """
    Evaluate clustering performance with various validity indices.

    Args:
        labels (np.ndarray): Cluster labels.
        data (np.ndarray): Data used for clustering.

    Returns:
        dict: Dictionary of validity indices.
    """
    sil = silhouette_score(data, labels, metric="euclidean")
    db = davies_bouldin_score(data, labels)
    ch = calinski_harabasz_score(data, labels)
    dunn, cop, sf = compute_custom_indices(data, labels)

    return {
        "Silhouette Score": sil,
        "Davies-Bouldin Score": db,
        "Calinski-Harabasz Score": ch,
        "Dunn Index": dunn,
        "COP Index": cop,
        "Score Function": sf,
    }


# Compute pairwise DTW distance matrix
def compute_dtw_distance_matrix(data):
    n_samples = data.shape[0]
    distance_matrix = np.zeros((n_samples, n_samples))

    for i in range(n_samples):
        for j in range(i + 1, n_samples):
            distance = dtw(data[i], data[j])
            distance_matrix[i, j] = distance
            distance_matrix[j, i] = distance

    return distance_matrix


# Compute pairwise SBD distance matrix
def compute_sbd_distance_matrix(data):
    n_samples = data.shape[0]
    distance_matrix = np.zeros((n_samples, n_samples))

    for i in range(n_samples):
        for j in range(i + 1, n_samples):
            distance = sbd_distance(data[i], data[j])
            distance_matrix[i, j] = distance
            distance_matrix[j, i] = distance

    return distance_matrix


# Run clustering with multiple algorithms
def run_clustering(data, algorithms, hyperparams, output_file="clustering_results.csv"):
    """
    Run clustering with multiple algorithms and hyperparameters, evaluate CVI scores, and save results.

    Args:
        data (pd.DataFrame): Preprocessed daily aggregate DataFrame.
        algorithms (dict): Dictionary of algorithms with their corresponding clustering functions.
        hyperparams (dict): Dictionary of hyperparameters for each algorithm.
        output_file (str): Path to save the CSV file with clustering results.

    Returns:
        pd.DataFrame: DataFrame containing CVI scores for all algorithm-hyperparameter combinations.
    """
    results = []
    features = data.drop(columns=["Date"]).values
    features = (features - np.mean(features, axis=1, keepdims=True)) / np.std(features, axis=1, keepdims=True)
    print(features.shape)

    for algo_name, algo_func in algorithms.items():
        algo_params = hyperparams.get(algo_name, {})
        param_grid = [dict(zip(algo_params.keys(), v)) for v in itertools.product(*algo_params.values())]

        for params in param_grid:
            if algo_name == "PAM" and params.get("metric") == "dtw":
                distance_matrix = compute_dtw_distance_matrix(features)
                model = algo_func(metric="precomputed", n_clusters=params["n_clusters"])
                labels = model.fit_predict(distance_matrix)
            elif algo_name in ["Single", "Average", "Complete", "Centroid", "Median"]:
                distance_metric = params.get("distance_metric", "euclidean")  # Default to 'euclidean' if not specified
                if distance_metric == "dtw":
                    distance_matrix = compute_dtw_distance_matrix(features)
                elif distance_metric == "sbd":
                    distance_matrix = compute_sbd_distance_matrix(features)
                elif distance_metric == "euclidean":
                    distance_matrix = features  # Use the features directly for Euclidean distance
                else:
                    raise ValueError(f"Unsupported distance metric: {distance_metric}")
                #model = algo_func(n_clusters=params["n_clusters"], linkage=params["linkage"], affinity="precomputed")
                #labels = model.fit_predict(distance_matrix)
            else:
                model = algo_func(**params)
                labels = model.fit_predict(features)

            scores = evaluate_clustering(labels, features)
            result = {"Algorithm": algo_name, **params, **scores}
            results.append(result)

    results_df = pd.DataFrame(results)
    results_df.to_csv(output_file, index=False)
    print(f"Clustering results saved to {output_file}")

    return results_df


# Visualize clustering results
def visualize_clusters(daily_aggregates, labels):
    """
    Visualize clustering results on the daily aggregates for all features.

    Args:
        daily_aggregates (pd.DataFrame): Preprocessed daily aggregates data.
        labels (array-like): Cluster labels for each day.
    """
    # Add cluster labels to the daily aggregates DataFrame
    daily_aggregates['Cluster'] = labels

    # Features to visualize
    features_to_plot = [
        'ess active power_sum',
        'grid active power_sum',
        'Consumption active power_sum',
        'Production active power_sum'
    ]

    plt.figure(figsize=(16, 8))

    for idx, feature in enumerate(features_to_plot, 1):
        plt.subplot(2, 2, idx)
        sns.scatterplot(
            x=daily_aggregates['Date'],
            y=daily_aggregates[feature],
            hue=daily_aggregates['Cluster'],
            palette="viridis",
            s=100,
            edgecolor="k",
        )
        plt.title(f'Cluster Visualization for {feature}', fontsize=14)
        plt.xlabel('Date', fontsize=12)
        plt.ylabel(feature, fontsize=12)
        plt.xticks(rotation=45)
        plt.grid(True, linestyle="--", alpha=0.7)

    plt.tight_layout()
    plt.show()


# Main Program to run the clustering
if __name__ == "__main__":
    # Load the dataset
    data = pd.read_csv("/home/jvaldes/Desktop/krishna-thesis/thesiscodeimplementation/data/Autohaus 2.csv")  # Replace with your dataset file

    # Perform EDA
    #processed_data = exploratory_data_analysis(data)
    plot_daily_mean_power(data)
    process_data = preprocess_for_clustering(data)



    #df = daily_aggregates
    # Define algorithms
    algorithms = {
        "PAM": lambda **kwargs: KMedoids(metric=kwargs.get("metric", "euclidean"), n_clusters=kwargs.get("n_clusters", 3)),
        "KShape": lambda **kwargs: KShape(n_clusters=kwargs.get("n_clusters", 3)),
        "DBA": lambda **kwargs: TimeSeriesKMeans(n_clusters=kwargs.get("n_clusters", 3), metric="dtw"),
        "Single": AgglomerativeClustering,
        "Average": AgglomerativeClustering,
        "Complete": AgglomerativeClustering,
        #"Ward": AgglomerativeClustering,
        "Centroid": AgglomerativeClustering,
        "Median" : AgglomerativeClustering
        }

    hyperparams = {
        "PAM": {"n_clusters": [3, 5, 10, 15, 25], "metric": ["euclidean", "dtw"]},
        "KShape": {"n_clusters": [3, 5, 10, 15, 25]},
        "DBA": {"n_clusters": [3, 5, 10, 15, 25]},
        "Single": {"n_clusters": [3, 5, 10, 15, 25], "distance_metric": ["euclidean", "dtw", "sbd"], "linkage": ["single"]},
        "Average": {"n_clusters": [3, 5, 10, 15, 25], "distance_metric": ["euclidean", "dtw", "sbd"], "linkage": ["average"]},
        "Complete": {"n_clusters": [3, 5, 10, 15, 25], "distance_metric": ["euclidean", "dtw", "sbd"], "linkage": ["complete"]},
        "Centroid": {"n_clusters": [3, 5, 10, 15, 25], "distance_metric": ["euclidean", "dtw", "sbd"], "linkage": ["centroid"]},
        "Median": {"n_clusters": [3, 5, 10, 15, 25], "distance_metric": ["euclidean", "dtw", "sbd"], "linkage": ["median"]},
        #"Ward": {"n_clusters": [2, 3], "linkage": ["ward"]},  # Only 'linkage' should be defined
    }


    # Run clustering
    #results_df = run_clustering(df, algorithms, hyperparams, output_file="clustering_results.csv")